### Hierarchy

- Map

NOTE: For 2.0 the constructor arguments have changed. Map now optionally accepts a collection, and only checks types in TypeScript.

An unordered iterable collection of key/value pairs that cannot contain two instances of the same key. In TypeScript it is a generic class that enforces at compile-time the type of the key and the type of the associated value.

To create a Map:

      var map = new go.Map(); // In TypeScript: new go.Map<string, number>();
      map.add("one", 1);
      map.add("two", 2);
      map.add("three", 3);
      // now map.count === 3
      // and map.getValue("two") === 2
      // and map.contains("zero") === false

You can iterate over the key/value pairs in a Map:

      var it = aMap.iterator;
      while (it.next()) {
        console.log(it.key + ": " + it.value);
      }

Or:

      aMap.each(function(kvp) {
        console.log(kvp.key + ": " + kvp.value);
      });

But note that there is no guaranteed ordering amongst the key/value pairs.

Call toKeySet to get a read-only Set that holds all of the keys of a Map. Iterating over that Set will produce values that are the keys in the Map.

Although not precisely implementing the features and semantics of the EcmaScript 6 Map class, this GoJS Map class has synonyms for the following methods and property:

- get(key): getValue, but returns null instead of undefined when key is not present
- set(key,val): add
- has(key): contains
- delete(key): remove
- clear(): clear
- size: count

The constructor now takes an optional Iterable or Array argument that provides the initial entries for the new Map.

Note that GoJS iteration is quite different than ES6 iteration, so that functionality has not been made somewhat compatible. These collection classes were defined in GoJS before the ES6 collection classes were proposed.

### Type parameters

- #### K

- #### V

## Index

### Constructors

- constructor

### Properties

- count
- iterator
- iteratorKeys
- iteratorValues
- size

### Methods

- add
- addAll
- all
- any
- clear
- contains
- copy
- delete
- each
- first
- get
- getValue
- has
- remove
- set
- toArray
- toKeySet

## Constructors

### constructor

- new Map(coll?: Iterable<KeyValuePair<K, V>> | Array<KeyValuePair<K, V>> | Map<K, V>): Map

- There are two possible constructors:

  `new go.Map()`, for JavaScript

  `new go.Map<K, V>()` for TypeScript

  In TypeScript, the two optional generic arguments describe the types of keys and the types of values that this Map may hold.

  For example, the expression:

      // TypeScript:
      new go.Map<string, go.Point>()

  produces a Map that has keys that must be strings and whose associated values must be Points.

  #### Parameters

  - ##### Optional coll: Iterable<KeyValuePair<K, V>> | Array<KeyValuePair<K, V>> | Map<K, V>

    an optional collection of keys/values to add, or an Array of { key: ..., value: ... } objects. Note that the key/value pairs are objects with "key" and "value" properties, not Arrays of length 2.

  #### Returns Map

## Properties

### Read-only count : number

- This read-only property is the number of associations in the Map.

### Read-only iterator : IMapIterator<K, V>

- Gets an object that you can use for iterating over the key-value pairs of a Map. Typical usage:

        var it = aMap.iterator;
        while (it.next()) {
          console.log("the key: " + it.key + " has value: " + it.value);
        }

### Read-only iteratorKeys : Iterator<K>

- Gets an object that you can use for iterating over the keys of a Map. Typical usage:

        var it = aMap.iteratorKeys;
        while (it.next()) {
          console.log("key: " + it.value);
        }

  since

    1.4

### Read-only iteratorValues : Iterator<V>

- Gets an object that you can use for iterating over the values of a Map. Typical usage:

        var it = aMap.iteratorValues;
        while (it.next()) {
          console.log("value: " + it.value);
        }

  since

    1.4

### Read-only size : number

- This read-only property is the number of associations in the Map.

## Methods

### add

- add(key: K, val: V): Map<K, V>

- Adds a key-value association to the Map, or replaces the value associated with the key if the key was already present in the map.

  Be careful not to call this method while iterating over the collection.

  #### Parameters

  - ##### key: K

    The key or index for storing the value in the Map.

  - ##### val: V

    The value to add to the Map, associated with the key.

  #### Returns Map<K, V>

  This modified Map.

### addAll

- addAll(coll: Iterable<KeyValuePair<K, V>> | Array<KeyValuePair<K, V>> | Map<K, V>): Map<K, V>

- Adds all of the key-value pairs of another Map to this Map. If a key is already present in this Map, its value is replaced with the corresponding value from the given map.

  Be careful not to call this method while iterating over the collection.

  #### Parameters

  - ##### coll: Iterable<KeyValuePair<K, V>> | Array<KeyValuePair<K, V>> | Map<K, V>

    the collection of keys/values to add, or an Array of { key: ..., value: ... } objects.

  #### Returns Map<K, V>

  This modified Map.

### Virtual all

- all(pred: function(a: KeyValuePair<K, V>): boolean): boolean

- This is true if all invocations of the given predicate on items in the collection are true.

  Call the given predicate on each key/value pair in the collection. As soon as a call returns false, this returns false. Otherwise this returns true. For an empty collection this returns true.

  since

    1.4

  #### Parameters

  - ##### pred: function(a: KeyValuePair<K, V>): boolean

    The argument to the predicate will be an object with both "key" and "value" properties. This function must not have any side-effects.

  #### Returns boolean

  True if all predicate calls are true; false otherwise.

### Virtual any

- any(pred: function(a: KeyValuePair<K, V>): boolean): boolean

- This is true if any invocation of the given predicate on items in the collection is true.

  Call the given predicate on each key/value pair in the collection. As soon as a call returns true, this returns true. Otherwise this returns false. For an empty collection this returns false.

  since

    1.4

  #### Parameters

  - ##### pred: function(a: KeyValuePair<K, V>): boolean

    The argument to the predicate will be an object with both "key" and "value" properties. This function must not have any side-effects.

  #### Returns boolean

  True if any predicate call is true; false otherwise.

### clear

- clear(): void

- Clears the Map, removing all key-value associations. This sets the count to zero.

  Be careful not to call this method while iterating over the collection.

  #### Returns void

### contains

- contains(key: K): boolean

- Returns whether the given key is in this Map.

  #### Parameters

  - ##### key: K

    The key to look up in the Map.

  #### Returns boolean

  Whether or not the key is contained within the Map.

### Virtual copy

- copy(): Map<K, V>

- Makes a shallow copy of this Map. The keys and their values are not copied, so if they are objects they may continue to be shared with the original Map.

  #### Returns Map<K, V>

  The new Map with copies of the same entries.

### delete

- delete(key: K): boolean

- Removes a key (if found) from the Map.

  Be careful not to call this method while iterating over the collection.

  #### Parameters

  - ##### key: K

    The key to insert.

  #### Returns boolean

  true if the key was found and removed, false otherwise.

### Virtual each

- each(func: function(a: KeyValuePair<K, V>): void): Map<K, V>

- Call the given function on each key/value pair in the collection.

  since

    1.4

  #### Parameters

  - ##### func: function(a: KeyValuePair<K, V>): void

    The argument to the function will be an object with both "key" and "value" properties. This function must not modify the collection.

  #### Returns Map<K, V>

  This Map itself

### first

- first(): KeyValuePair<K, V>

- Returns the first key/value pair in the collection, or null if there is none.

  since

    1.4

  #### Returns KeyValuePair<K, V>

  This returns null if there are no items in the collection.

### get

- get(key: K): V | null

- Returns the value associated with a key.

  #### Parameters

  - ##### key: K

    The key to look up in the Map.

  #### Returns V | null

  The value associated with the given key, or null if not present in the Map.

### getValue

- getValue(key: K): V | null

- Returns the value associated with a key.

  #### Parameters

  - ##### key: K

    The key to look up in the Map.

  #### Returns V | null

  The value associated with the given key, or null if not present in the Map.

### has

- has(key: K): boolean

- Returns whether the given key is in this Map.

  #### Parameters

  - ##### key: K

    The key to look up in the Map.

  #### Returns boolean

  Whether or not the key is contained within the Map.

### remove

- remove(key: K): boolean

- Removes a key (if found) from the Map.

  Be careful not to call this method while iterating over the collection.

  #### Parameters

  - ##### key: K

    The key to remove.

  #### Returns boolean

  true if the key was found and removed, false otherwise.

### set

- set(key: K, val: V): Map<K, V>

- Adds a key-value association to the Map, or replaces the value associated with the key if the key was already present in the map.

  Be careful not to call this method while iterating over the collection.

  #### Parameters

  - ##### key: K

    The key or index for storing the value in the Map.

  - ##### val: V

    The value to add to the Map, associated with the key.

  #### Returns Map<K, V>

  This modified Map.

### toArray

- toArray(): Array<KeyValuePair<K, V>>

- Produces a JavaScript Array of key/value pair objects from the contents of this Map.

  #### Returns Array<KeyValuePair<K, V>>

  A copy of the Map in Array form, each element being an Object with 'key' and 'value' properties.

### toKeySet

- toKeySet(): Set<K>

- Produces a Set that provides a read-only view onto the keys of this Map. The collection of keys is not copied.

  #### Returns Set<K>

Copyright © 1998-2019 by Northwoods Software Corporation.